using System;
using System.Collections.Generic;
using System.Text;
using Foss.FossDoc.ObjectModel.DataRepresentation.Plugins.Forms;
using Foss.FossDoc.ObjectModel.DataRepresentation.Plugins;
using Foss.FossDoc.ObjectModel.DataRepresentation.View;
using Foss.FossDoc.ObjectModel.DataRepresentation.View.DocumentCard;
using Foss.FossDoc.ObjectModel.Data;
using DS;


namespace Foss.FossDoc.EDMS.InternalLetter
{
    public class Form : Foss.FossDoc.EDMS.Plugins.Documents.Internal.InternalForm
    {
        protected override void ActivateRoutine()
        {
            base.ActivateRoutine();
            
            _GenerateDisplayNameAndDisableField();
        }

        private void _GenerateDisplayNameAndDisableField()
        {
            IDocumentCardField documentCardField = Fields[Foss.FossDoc.ApplicationServer.ObjectDataManagment.Schema.PropertyTags.DisplayName];
            if (documentCardField == null)
                return;

            documentCardField.ReadOnly = true;

            if (IsNew)
            {
                documentCardField.Value = _GenerateDisplayName();

                IDocumentCardField fieldFrom = Fields[Foss.FossDoc.ExternalModules.EDMS.Schema.PropertyTags.CA_OutgoingInternal.EDMS_FIELD_INTERNAL_AUTHOR];
                if (fieldFrom != null)
                {
                    fieldFrom.Value=ObjectHolder.Session.ActAsUserOID;
                }
            }
        }

        private string _GenerateDisplayName()
        {
            string employeeName;
            using (IObjectHolder employee = ObjectHolder.Session.OpenObject(ObjectHolder.Session.ActAsUserOID))
            {
                employeeName = employee.DisplayName;
            }

            return string.Format(
                    "{0} ({1}) {2}",
                    ObjectHolder.Category.DisplayName,
                    employeeName,
                    ObjectHolder.Session.UTCTime.ToLocalTime());
        }

        protected override void SaveRoutine()
        {
            base.SaveRoutine();
        }
    }
}